<div>
    <div class="row justify-content-center">
        <div class="col-md-8">
            <h4>Registration</h4>

            <div class="alert alert-success" *ngIf="success">
                <strong>Registration saved!</strong> You will get email after admin confirmation.
            </div>

            <div class="alert alert-danger" *ngIf="error">
                <strong>Registration failed!</strong> Please try again later.
            </div>

            <div class="alert alert-danger" *ngIf="errorUserExists">
                <strong>Username already registered!</strong> Please choose another one.
            </div>

            <div class="alert alert-danger" *ngIf="errorEmailExists">
                <strong>Email is already in use!</strong> Please choose another one.
            </div>

            <div class="alert alert-danger" *ngIf="doNotMatch">
                The password and its confirmation do not match!
            </div>
        </div>
    </div>
    <div class="row justify-content-center">
        <div class="col-md-8">
            <form name="form" role="form" (ngSubmit)="register()" #registerForm="ngForm" *ngIf="!success">
                <div class="form-group">
                    <label class="form-control-label" for="username">Username</label>
                    <input type="text" class="form-control" [(ngModel)]="registerAccount.username" id="username"
                           name="username" #username="ngModel" placeholder="Username"
                           required minlength="1" maxlength="50" pattern="^[_.@A-Za-z0-9-]*$">
                    <div *ngIf="username.dirty && username.invalid">
                        <small class="form-text text-danger" *ngIf="username.errors.required">
                            Your username is required.
                        </small>
                        <small class="form-text text-danger" *ngIf="username.errors.minlength">
                            Your username is required to be at least 1 character.
                        </small>
                        <small class="form-text text-danger" *ngIf="username.errors.maxlength">
                            Your username cannot be longer than 50 characters.
                        </small>
                        <small class="form-text text-danger" *ngIf="username.errors.pattern">
                            Your username can only contain letters and digits.
                        </small>
                    </div>
                </div>
                <div class="form-group">
                    <label class="form-control-label" for="firstName">First name</label>
                    <input type="text" class="form-control" [(ngModel)]="registerAccount.person.firstName" id="firstName"
                           name="firstName" #username="ngModel" placeholder="First name"
                           required minlength="1" maxlength="50">
                </div>
                <div class="form-group">
                    <label class="form-control-label" for="lastName">Last name</label>
                    <input type="text" class="form-control" [(ngModel)]="registerAccount.person.lastName" id="lastName"
                           name="lastName" #username="ngModel" placeholder="Last name"
                           required minlength="1" maxlength="50">
                </div>
                <div class="form-group">
                    <label class="form-control-label" for="email">Email</label>
                    <input type="email" class="form-control" id="email" name="email" #email="ngModel"
                           placeholder="Email"
                           [(ngModel)]="registerAccount.email" minlength=5 maxlength=254 email required>
                    <div *ngIf="email.dirty && email.invalid">
                        <small class="form-text text-danger" *ngIf="email.errors.required">
                            Your email is required.
                        </small>
                        <small class="form-text text-danger" *ngIf="email.errors.invalid">
                            Your email is invalid.
                        </small>
                        <small class="form-text text-danger" *ngIf="email.errors.minlength">
                            Your email is required to be at least 5 characters.
                        </small>
                        <small class="form-text text-danger" *ngIf="email.errors.maxlength">
                            Your email cannot be longer than 100 characters.
                        </small>
                    </div>
                </div>
                <div class="form-group">
                    <label class="form-control-label" for="password">New password</label>
                    <input type="password" class="form-control" id="password" name="password" #password="ngModel"
                           placeholder="New password"
                           [(ngModel)]="registerAccount.password" minlength=4 maxlength=50 required>
                    <div *ngIf="password.dirty && password.invalid">
                        <small class="form-text text-danger" *ngIf="password.errors.required">
                            Your password is required.
                        </small>
                        <small class="form-text text-danger" *ngIf="password.errors.minlength">
                            Your password is required to be at least 4 characters.
                        </small>
                        <small class="form-text text-danger" *ngIf="password.errors.maxlength">
                            Your password cannot be longer than 50 characters.
                        </small>
                    </div>
                </div>
                <div class="form-group">
                    <label class="form-control-label" for="confirmPassword">New password confirmation</label>
                    <input type="password" class="form-control" id="confirmPassword" name="confirmPassword"
                           #confirmPasswordInput="ngModel" placeholder="Confirm password"
                           [(ngModel)]="confirmPassword" minlength=4 maxlength=50 required>
                    <div *ngIf="confirmPasswordInput.dirty && confirmPasswordInput.invalid">
                        <small class="form-text text-danger" *ngIf="confirmPasswordInput.errors.required">
                            Your confirmation password is required.
                        </small>
                        <small class="form-text text-danger" *ngIf="confirmPasswordInput.errors.minlength">
                            Your confirmation password is required to be at least 4 characters.
                        </small>
                        <small class="form-text text-danger" *ngIf="confirmPasswordInput.errors.maxlength">
                            Your confirmation password cannot be longer than 50 characters.
                        </small>
                    </div>
                </div>
                <button type="submit" [disabled]="registerForm.form.invalid" class="btn btn-primary">Register</button>
            </form>
            <p></p>
            <div class="alert alert-warning">
                <a class="alert-link" routerLink="/login" routerLinkActive="active">Sign in</a><span>, if you have created account<br/></span>
            </div>
        </div>
    </div>
</div>
